#include <bits/stdc++.h>
using namespace std;
int n,t;
int a[500001];
bool cmp(int &x, int &y)
{
    return abs(x)<abs(y);
}
int main()
{
    ifstream cin("explor.inp");
    ofstream cout("explor.out");
    cin>>t>>n;
    for(int i=1;i<=n;i++)
    {
        cin>>a[i];
    }
    sort(a+1,a+n+1,cmp);
    int dem=0;
    a[0]=0;
    for(int i=1;i<=n;i++)
    {
        if(t>abs(a[i]-a[i-1]))
        {
            dem++;
            t-=abs(a[i]-a[i-1]);
        }
        else
        {
            break;
        }
    }
    cout<<dem;
}
